﻿// JScript 文件
function CreateGrid(itemHeight, totalWidth, itemNum, bgColor, borderColor, itemText)
{
	var div_grid = 0;
	var div_subitem = 0;
	var strSubInnerHTML = "";
	var itemWidth = totalWidth/itemNum-1;	//减1是因为要设置右边框
	
	div_grid = document.createElement("div");
	div_subitem = document.createElement("div");
	div_subitem.style.cssText = "width:"+itemWidth+"px;height:"+itemHeight+";margin:auto;position:relative;background-color:"+bgColor+";border-right:solid 1px "+borderColor+";float:left;";
	for(var i = 0; i < itemNum; i++)
	{
		div_subitem.index = i;
		if(itemText != null)
		{
			div_subitem.innerText = itemText[i];
		}
		strSubInnerHTML += div_subitem.outerHTML;
	}
	div_grid.innerHTML = strSubInnerHTML;
	return div_grid;
}

function RecDataTimeShow(bg_div, title)
{
	var totalWidth = 480;
	var itemHeight = 16;
	var titleWidth = 80;
	var title_div = 0;
	var tick_div = 0;
	var timeinfo_div = 0;
	var popupinfo_div = 0;
	var pointer_div = 0;
	var strInnerHTML = "";
	//创建标题
	title_div = document.createElement("div");
	title_div.style.cssText = "margin:auto;border:solid 1px;height:"+itemHeight+"px;width:"+(titleWidth-3)+"px;position:relative;text-align:center;float:left;";
	title_div.innerHTML = title;
	strInnerHTML += title_div.outerHTML;
	//创建刻度
	var itemText = new Array(6);
	for(var i = 0; i < 6; i++)
	{
		itemText[i] = " " + AlignTime(i*4) + ":00";
	}
	tick_div = CreateGrid(itemHeight, totalWidth, 6, "#D4E8FE", "#000000", itemText);
	tick_div.style.cssText = "margin:auto;width:"+totalWidth+"px;height:"+itemHeight+"px;position:relative;border-top:solid 1px;border-bottom:solid 1px;border-right:solid 1px;float:left;text-align:left;";
	strInnerHTML += tick_div.outerHTML;
	
	//创建通道标题
	title_div.style.cssText = "margin:auto;border-left:solid 1px;border-bottom:solid 1px;border-right:solid 1px;height:"+itemHeight+"px;width:"+(titleWidth-3)+"px;position:relative;text-align:center;float:left;";
	//创建排程设置区域
	timeinfo_div = CreateGrid(itemHeight, totalWidth, 24, "#fff", "#d0c0ff");
	for(var channel = 1; channel <= g_channelList.length; channel++)
	{
		title_div.innerHTML = str_ch+" "+channel;
		strInnerHTML += title_div.outerHTML;
		timeinfo_div.id = "div_time_info0" + channel;
		timeinfo_div.index = channel;
		timeinfo_div.style.cssText = "margin:auto;width:"+totalWidth+"px;height:"+itemHeight+"px;position:relative;border-bottom:solid 1px;border-right:solid 1px;float:left;";	
		strInnerHTML += timeinfo_div.outerHTML;
	}
	
	bg_div.innerHTML = strInnerHTML;
}

function ClearTimeInfo(bg_div)
{
	for(var channel = 1; channel <= g_channelList.length; channel++)
	{
		var timeinfo_div = document.getElementById("div_time_info0"+channel);
		if(timeinfo_div == null)
		{
			continue;
		}
		var timeinfo_item_div = timeinfo_div.getElementsByTagName("div");
		while(timeinfo_item_div.length > 24)
		{
			timeinfo_div.removeChild(timeinfo_item_div[24]);
		}
	}
}

//channel从1开始计数
function SetTimeInfo(bg_div, timeSecArray, channel)
{
	if(channel <= 0)
	{
		window.alert("通道从1计数");
		return;
	}
	var timeinfo_div = document.getElementById("div_time_info0"+channel);
	if(timeinfo_div == null)
	{
		return;
	}
	var timeinfo_item_div = timeinfo_div.getElementsByTagName("div");
	var time_section_div = document.createElement("div");
	time_section_div.style.cssText = "background-color:#8080ff; border:0; position:absolute;";
	time_section_div.style.height = timeinfo_item_div[0].style.height;
	timeinfo_div.appendChild(time_section_div);
	
	var offsetLeft = 0;
	var offsetTop = timeinfo_item_div[0].offsetTop;
	
	var offsetParent = timeinfo_div;
	while(offsetParent != time_section_div.offsetParent)
	{
	    offsetLeft += offsetParent.offsetLeft;
	    offsetTop += offsetParent.offsetTop;
	    offsetParent = offsetParent.offsetParent;
	}
	
	var divArray = new Array();
	var length = timeSecArray.length;
	
	for(var i = 0; i < length; i++)
	{
	    var minObjIndex = 0;
	    for(var j = 1; j < timeSecArray.length; j++)
	    {
	        if(timeSecArray[minObjIndex].startTime > timeSecArray[j].startTime)
	        {
	            minObjIndex = j;
	        }
	    }
	    
	    var newStart = Math.floor(timeSecArray[minObjIndex].startTime/3600/24*timeinfo_div.offsetWidth);
	    var newEnd = Math.floor(timeSecArray[minObjIndex].endTime/3600/24*timeinfo_div.offsetWidth);
	    if(divArray.length > 0)
	    {
	        if(newStart <= divArray[divArray.length-1].endPos)
	        {
	            divArray[divArray.length-1].endPos = Math.max(newEnd, divArray[divArray.length-1].endPos);
	        }
	        else
	        {
	            divArray[divArray.length] = new Object();
	            divArray[divArray.length-1].startPos = newStart;
	            divArray[divArray.length-1].endPos = newEnd;
	        }
	    }
	    else
	    {
	        divArray[divArray.length] = new Object();
	        divArray[divArray.length-1].startPos = newStart;
	        divArray[divArray.length-1].endPos = newEnd;
	    }
	    timeSecArray.splice(minObjIndex, 1);
	}
	
	for(i = 0; i < divArray.length; i++)
	{
	    time_section_div.style.left = divArray[i].startPos + offsetLeft;
	    time_section_div.style.top = offsetTop;
	    time_section_div.style.width = divArray[i].endPos - divArray[i].startPos+1;
	    if(i < (divArray.length-1))
	    {
	        time_section_div = document.createElement("div");
	        time_section_div.style.cssText = "background-color:#8080ff; border:0; position:absolute;";
	        time_section_div.style.height = timeinfo_item_div[0].style.height;
	        timeinfo_div.appendChild(time_section_div);
	    }
	}
}

